##// END OF EJS Templates
Raspberry Pi 4: inital model support...
drtyhlpr -
r621:7319d292c44d
parent child
Show More
@@ -1,869 +1,883
1 1 #!/bin/sh
2 2 ########################################################################
3 3 # rpi23-gen-image.sh 2015-2017
4 4 #
5 5 # Advanced Debian "stretch" and "buster" bootstrap script for Raspberry Pi
6 6 #
7 7 # This program is free software; you can redistribute it and/or
8 8 # modify it under the terms of the GNU General Public License
9 9 # as published by the Free Software Foundation; either version 2
10 10 # of the License, or (at your option) any later version.
11 11 #
12 12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
13 13 #
14 14 # Big thanks for patches and enhancements by 20+ github contributors!
15 15 ########################################################################
16 16
17 17 # Are we running as root?
18 18 if [ "$(id -u)" -ne "0" ] ; then
19 19 echo "error: this script must be executed with root privileges!"
20 20 exit 1
21 21 fi
22 22
23 23 # Check if ./functions.sh script exists
24 24 if [ ! -r "./functions.sh" ] ; then
25 25 echo "error: './functions.sh' required script not found!"
26 26 exit 1
27 27 fi
28 28
29 29 # Load utility functions
30 30 . ./functions.sh
31 31
32 32 # Load parameters from configuration template file
33 33 if [ -n "$CONFIG_TEMPLATE" ] ; then
34 34 use_template
35 35 fi
36 36
37 37 # Introduce settings
38 38 set -e
39 39 echo -n -e "\n#\n# RPi 0/1/2/3 Bootstrap Settings\n#\n"
40 40 set -x
41 41
42 42 # Raspberry Pi model configuration
43 43 RPI_MODEL=${RPI_MODEL:=2}
44 44
45 45 # Debian release
46 46 RELEASE=${RELEASE:=buster}
47 47
48 48 # Kernel Branch
49 49 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
50 50
51 51 # URLs
52 52 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
53 53 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
54 54 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
55 55 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
56 56 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
57 57 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
58 58 VIDEOCORE_URL=${VIDEOCORE_URL:=https://github.com/raspberrypi/userland}
59 59 BLUETOOTH_URL=${BLUETOOTH_URL:=https://github.com/RPi-Distro/pi-bluetooth.git}
60 60 NEXMON_URL=${NEXMON_URL:=https://github.com/seemoo-lab/nexmon.git}
61 61 SYSTEMDSWAP_URL=${SYSTEMDSWAP_URL:=https://github.com/Nefelim4ag/systemd-swap.git}
62 62
63 63 # Kernel deb packages for 32bit kernel
64 64 RPI_32_KERNEL_URL=${RPI_32_KERNEL_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel_20180422-141901_armhf.deb}
65 65 RPI_32_KERNELHEADER_URL=${RPI_32_KERNELHEADER_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel-headers_20180422-141901_armhf.deb}
66 66 # Kernel has KVM and zswap enabled - use if KERNEL_* parameters and precompiled kernel are used
67 67 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.14.80.20181113/bcmrpi3-kernel-bis-4.14.80.20181113.tar.xz}
68 68 # Default precompiled 64bit kernel
69 69 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.14.80.20181113/bcmrpi3-kernel-4.14.80.20181113.tar.xz}
70 70 # Generic
71 71 RPI3_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI3_64_DEF_KERNEL_URL}
72 72 # Kali kernel src - used if ENABLE_NEXMON=true (they patch the wlan kernel modul)
73 73 KALI_KERNEL_URL=${KALI_KERNEL_URL:=https://github.com/Re4son/re4son-raspberrypi-linux.git}
74 74
75 75 # Build directories
76 76 WORKDIR=$(pwd)
77 77 BASEDIR=${BASEDIR:=${WORKDIR}/images/${RELEASE}}
78 78 BUILDDIR="${BASEDIR}/build"
79 79
80 80 # Chroot directories
81 81 R="${BUILDDIR}/chroot"
82 82 ETC_DIR="${R}/etc"
83 83 LIB_DIR="${R}/lib"
84 84 BOOT_DIR="${R}/boot/firmware"
85 85 KERNEL_DIR="${R}/usr/src/linux"
86 86 WLAN_FIRMWARE_DIR="${LIB_DIR}/firmware/brcm"
87 87 BLUETOOTH_FIRMWARE_DIR="${ETC_DIR}/firmware/bt"
88 88
89 89 # Firmware directory: Blank if download from github
90 90 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
91 91
92 92 # General settings
93 93 SET_ARCH=${SET_ARCH:=32}
94 94 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
95 95 PASSWORD=${PASSWORD:=raspberry}
96 96 USER_PASSWORD=${USER_PASSWORD:=raspberry}
97 97 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
98 98 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
99 99 EXPANDROOT=${EXPANDROOT:=true}
100 100 ENABLE_DPHYSSWAP=${ENABLE_DPHYSSWAP:=true}
101 101
102 102 # Keyboard settings
103 103 XKB_MODEL=${XKB_MODEL:=""}
104 104 XKB_LAYOUT=${XKB_LAYOUT:=""}
105 105 XKB_VARIANT=${XKB_VARIANT:=""}
106 106 XKB_OPTIONS=${XKB_OPTIONS:=""}
107 107
108 108 # Network settings (DHCP)
109 109 ENABLE_DHCP=${ENABLE_DHCP:=true}
110 110
111 111 # Network settings (static)
112 112 NET_ADDRESS=${NET_ADDRESS:=""}
113 113 NET_GATEWAY=${NET_GATEWAY:=""}
114 114 NET_DNS_1=${NET_DNS_1:=""}
115 115 NET_DNS_2=${NET_DNS_2:=""}
116 116 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
117 117 NET_NTP_1=${NET_NTP_1:=""}
118 118 NET_NTP_2=${NET_NTP_2:=""}
119 119
120 120 # APT settings
121 121 APT_PROXY=${APT_PROXY:=""}
122 122 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
123 123 KEEP_APT_PROXY=${KEEP_APT_PROXY:=false}
124 124
125 125 # Feature settings
126 126 ENABLE_PRINTK=${ENABLE_PRINTK:=false}
127 127 ENABLE_BLUETOOTH=${ENABLE_BLUETOOTH:=false}
128 128 ENABLE_MINIUART_OVERLAY=${ENABLE_MINIUART_OVERLAY:=false}
129 129 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
130 130 ENABLE_I2C=${ENABLE_I2C:=false}
131 131 ENABLE_SPI=${ENABLE_SPI:=false}
132 132 ENABLE_IPV6=${ENABLE_IPV6:=true}
133 133 ENABLE_SSHD=${ENABLE_SSHD:=true}
134 134 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
135 135 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
136 136 ENABLE_SOUND=${ENABLE_SOUND:=true}
137 137 ENABLE_DBUS=${ENABLE_DBUS:=true}
138 138 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
139 139 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
140 140 ENABLE_XORG=${ENABLE_XORG:=false}
141 141 ENABLE_WM=${ENABLE_WM:=""}
142 142 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
143 143 ENABLE_USER=${ENABLE_USER:=true}
144 144 USER_NAME=${USER_NAME:="pi"}
145 145 ENABLE_ROOT=${ENABLE_ROOT:=false}
146 146 ENABLE_QEMU=${ENABLE_QEMU:=false}
147 147 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
148 148
149 149 # SSH settings
150 150 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
151 151 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
152 152 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
153 153 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
154 154 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
155 155
156 156 # Advanced settings
157 157 ENABLE_SYSTEMDSWAP=${ENABLE_SYSTEMDSWAP:=false}
158 158 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
159 159 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
160 160 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
161 161 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
162 162 ENABLE_USBBOOT=${ENABLE_USBBOOT=false}
163 163 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
164 164 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=false}
165 165 ENABLE_NEXMON=${ENABLE_NEXMON:=false}
166 166 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
167 167 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
168 168 NEXMONSRC_DIR=${NEXMONSRC_DIR:=""}
169 169 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
170 170 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
171 171 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
172 172 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
173 173 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
174 174 ENABLE_SPLASH=${ENABLE_SPLASH:=true}
175 175 ENABLE_LOGO=${ENABLE_LOGO:=true}
176 176 ENABLE_SILENT_BOOT=${ENABLE_SILENT_BOOT=false}
177 177 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
178 178
179 179 # Kernel compilation settings
180 180 BUILD_KERNEL=${BUILD_KERNEL:=true}
181 181 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
182 182 KERNEL_THREADS=${KERNEL_THREADS:=1}
183 183 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
184 184 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
185 185 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
186 186 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
187 187 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
188 188 KERNEL_ZSWAP=${KERNEL_ZSWAP:=false}
189 189 KERNEL_VIRT=${KERNEL_VIRT:=false}
190 190 KERNEL_BPF=${KERNEL_BPF:=false}
191 191 KERNEL_DEFAULT_GOV=${KERNEL_DEFAULT_GOV:=ondemand}
192 192 KERNEL_SECURITY=${KERNEL_SECURITY:=false}
193 193 KERNEL_NF=${KERNEL_NF:=false}
194 194
195 195 # Kernel compilation from source directory settings
196 196 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
197 197 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
198 198 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
199 199 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
200 200
201 201 # Reduce disk usage settings
202 202 REDUCE_APT=${REDUCE_APT:=true}
203 203 REDUCE_DOC=${REDUCE_DOC:=true}
204 204 REDUCE_MAN=${REDUCE_MAN:=true}
205 205 REDUCE_VIM=${REDUCE_VIM:=false}
206 206 REDUCE_BASH=${REDUCE_BASH:=false}
207 207 REDUCE_HWDB=${REDUCE_HWDB:=true}
208 208 REDUCE_SSHD=${REDUCE_SSHD:=true}
209 209 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
210 210
211 211 # Encrypted filesystem settings
212 212 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
213 213 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
214 214 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
215 215 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
216 216 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
217 217 #Dropbear-initramfs supports unlocking encrypted filesystem via SSH on bootup
218 218 CRYPTFS_DROPBEAR=${CRYPTFS_DROPBEAR:=false}
219 219 #Provide your own Dropbear Public RSA-OpenSSH Key otherwise it will be generated
220 220 CRYPTFS_DROPBEAR_PUBKEY=${CRYPTFS_DROPBEAR_PUBKEY:=""}
221 221
222 222 # Chroot scripts directory
223 223 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
224 224
225 225 # Packages required in the chroot build environment
226 226 APT_INCLUDES=${APT_INCLUDES:=""}
227 227 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup,libnss-systemd"
228 228
229 229 # Packages to exclude from chroot build environment
230 230 APT_EXCLUDES=${APT_EXCLUDES:=""}
231 231
232 232 # Packages required for bootstrapping
233 233 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo"
234 234 MISSING_PACKAGES=""
235 235
236 236 # Packages installed for c/c++ build environment in chroot (keep empty)
237 237 COMPILER_PACKAGES=""
238 238
239 239 # Check if apt-cacher-ng has port 3142 open and set APT_PROXY
240 240 APT_CACHER_RUNNING=$(lsof -i :3142 | cut -d ' ' -f3 | uniq | sed '/^\s*$/d')
241 241 if [ "${APT_CACHER_RUNNING}" = "apt-cacher-ng" ] ; then
242 242 APT_PROXY=http://127.0.0.1:3142/
243 243 fi
244 244
245 245 # Setup architecture specific settings
246 246 if [ -n "$SET_ARCH" ] ; then
247 247 # 64-bit configuration
248 248 if [ "$SET_ARCH" = 64 ] ; then
249 249 # General 64-bit depended settings
250 250 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
251 251 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
252 252 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
253 253
254 254 # Raspberry Pi model specific settings
255 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
256 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
255 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
256 if [ "$RPI_MODEL" != 4 ] ; then
257 257 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
258 else
259 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2711_defconfig}
260 fi
261
262 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
258 263 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
259 264 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
260 265 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
261 266 else
262 echo "error: Only Raspberry PI 3 and 3B+ support 64-bit"
267 echo "error: Only Raspberry PI 3, 3B+ and 4 support 64-bit"
263 268 exit 1
264 269 fi
265 270 fi
266 271
267 272 # 32-bit configuration
268 273 if [ "$SET_ARCH" = 32 ] ; then
269 274 # General 32-bit dependend settings
270 275 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
271 276 KERNEL_ARCH=${KERNEL_ARCH:=arm}
272 277 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
273 278
274 279 # Raspberry Pi model specific settings
275 280 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
276 281 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
277 282 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
278 283 RELEASE_ARCH=${RELEASE_ARCH:=armel}
279 284 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
280 285 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
281 286 fi
282 287
283 288 # Raspberry Pi model specific settings
284 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
285 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
289 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
290 if [ "$RPI_MODEL" != 4 ] ; then
286 291 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
292 else
293 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2711_defconfig}
294 fi
295
296 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
287 297 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
288 298 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
289 299 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
290 300 fi
291 301 fi
292 302 # SET_ARCH not set
293 303 else
294 304 echo "error: Please set '32' or '64' as value for SET_ARCH"
295 305 exit 1
296 306 fi
297 307 # Device specific configuration and U-Boot configuration
298 308 case "$RPI_MODEL" in
299 309 0)
300 310 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
301 311 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
302 312 ;;
303 313 1)
304 314 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
305 315 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
306 316 ;;
307 317 1P)
308 318 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
309 319 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
310 320 ;;
311 321 2)
312 322 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
313 323 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
314 324 ;;
315 325 3)
316 326 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
317 327 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
318 328 ;;
319 329 3P)
320 330 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
321 331 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
322 332 ;;
333 4)
334 DTB_FILE=${DTB_FILE:=bcm2711-rpi-4-b.dtb}
335 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_4_defconfig}
336 ;;
323 337 *)
324 338 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
325 339 exit 1
326 340 ;;
327 341 esac
328 342
329 343 # Raspberry PI 0,3,3P with Bluetooth and Wifi onboard
330 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
344 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
331 345 # Include bluetooth packages on supported boards
332 346 if [ "$ENABLE_BLUETOOTH" = true ] ; then
333 347 APT_INCLUDES="${APT_INCLUDES},bluetooth,bluez"
334 348 fi
335 349 if [ "$ENABLE_WIRELESS" = true ] ; then
336 350 APT_INCLUDES="${APT_INCLUDES},wireless-tools,crda,wireless-regdb"
337 351 fi
338 352 else # Raspberry PI 1,1P,2 without Wifi and bluetooth onboard
339 353 # Check if the internal wireless interface is not supported by the RPi model
340 354 if [ "$ENABLE_WIRELESS" = true ] || [ "$ENABLE_BLUETOOTH" = true ]; then
341 355 echo "error: The selected Raspberry Pi model has no integrated interface for wireless or bluetooth"
342 356 exit 1
343 357 fi
344 358 fi
345 359
346 360 if [ "$BUILD_KERNEL" = false ] && [ "$ENABLE_NEXMON" = true ]; then
347 361 echo "error: You have to compile kernel sources, if you want to enable nexmon"
348 362 exit 1
349 363 fi
350 364
351 365 # Prepare date string for default image file name
352 366 DATE="$(date +%Y-%m-%d)"
353 367 if [ -z "$KERNEL_BRANCH" ] ; then
354 368 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
355 369 else
356 370 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
357 371 fi
358 372
359 373 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
360 374 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
361 375 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
362 376 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
363 377 exit 1
364 378 fi
365 379 fi
366 380
367 381 # Add cmake to compile videocore sources
368 382 if [ "$ENABLE_VIDEOCORE" = true ] ; then
369 383 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
370 384 fi
371 385
372 386 # Add deps for nexmon
373 387 if [ "$ENABLE_NEXMON" = true ] ; then
374 388 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libgmp3-dev gawk qpdf bison flex make autoconf automake build-essential libtool"
375 389 fi
376 390
377 391 # Add libncurses5 to enable kernel menuconfig
378 392 if [ "$KERNEL_MENUCONFIG" = true ] ; then
379 393 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
380 394 fi
381 395
382 396 # Add ccache compiler cache for (faster) kernel cross (re)compilation
383 397 if [ "$KERNEL_CCACHE" = true ] ; then
384 398 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
385 399 fi
386 400
387 401 # Add cryptsetup package to enable filesystem encryption
388 402 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
389 403 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
390 404 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
391 405
392 406 # If cryptfs,dropbear and initramfs are enabled include dropbear-initramfs package
393 407 if [ "$CRYPTFS_DROPBEAR" = true ] && [ "$ENABLE_INITRAMFS" = true ]; then
394 408 APT_INCLUDES="${APT_INCLUDES},dropbear-initramfs"
395 409 fi
396 410
397 411 if [ -z "$CRYPTFS_PASSWORD" ] ; then
398 412 echo "error: no password defined (CRYPTFS_PASSWORD)!"
399 413 exit 1
400 414 fi
401 415 ENABLE_INITRAMFS=true
402 416 fi
403 417
404 418 # Add initramfs generation tools
405 419 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
406 420 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
407 421 fi
408 422
409 423 # Add device-tree-compiler required for building the U-Boot bootloader
410 424 if [ "$ENABLE_UBOOT" = true ] ; then
411 425 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex,bc"
412 426 fi
413 427
414 428 if [ "$ENABLE_USBBOOT" = true ] ; then
415 429 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 2 ]; then
416 430 echo "error: Booting from USB alone is only supported by Raspberry Pi 3 and 3P"
417 431 exit 1
418 432 fi
419 433 fi
420 434
421 435 # Check if root SSH (v2) public key file exists
422 436 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
423 437 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
424 438 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
425 439 exit 1
426 440 fi
427 441 fi
428 442
429 443 # Check if $USER_NAME SSH (v2) public key file exists
430 444 if [ -n "$SSH_USER_PUB_KEY" ] ; then
431 445 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
432 446 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
433 447 exit 1
434 448 fi
435 449 fi
436 450
437 451 if [ "$ENABLE_NEXMON" = true ] && [ -n "$KERNEL_BRANCH" ] ; then
438 452 echo "error: Please unset KERNEL_BRANCH if using ENABLE_NEXMON"
439 453 exit 1
440 454 fi
441 455
442 456 # Check if all required packages are installed on the build system
443 457 for package in $REQUIRED_PACKAGES ; do
444 458 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
445 459 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
446 460 fi
447 461 done
448 462
449 463 # If there are missing packages ask confirmation for install, or exit
450 464 if [ -n "$MISSING_PACKAGES" ] ; then
451 465 echo "the following packages needed by this script are not installed:"
452 466 echo "$MISSING_PACKAGES"
453 467
454 468 printf "\ndo you want to install the missing packages right now? [y/n] "
455 469 read -r confirm
456 470 [ "$confirm" != "y" ] && exit 1
457 471
458 472 # Make sure all missing required packages are installed
459 473 apt-get -qq -y install `echo "${MISSING_PACKAGES}" | sed "s/ //"`
460 474 fi
461 475
462 476 # Check if ./bootstrap.d directory exists
463 477 if [ ! -d "./bootstrap.d/" ] ; then
464 478 echo "error: './bootstrap.d' required directory not found!"
465 479 exit 1
466 480 fi
467 481
468 482 # Check if ./files directory exists
469 483 if [ ! -d "./files/" ] ; then
470 484 echo "error: './files' required directory not found!"
471 485 exit 1
472 486 fi
473 487
474 488 # Check if specified KERNELSRC_DIR directory exists
475 489 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
476 490 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
477 491 exit 1
478 492 fi
479 493
480 494 # Check if specified UBOOTSRC_DIR directory exists
481 495 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
482 496 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
483 497 exit 1
484 498 fi
485 499
486 500 # Check if specified VIDEOCORESRC_DIR directory exists
487 501 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
488 502 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
489 503 exit 1
490 504 fi
491 505
492 506 # Check if specified FBTURBOSRC_DIR directory exists
493 507 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
494 508 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
495 509 exit 1
496 510 fi
497 511
498 512 # Check if specified NEXMONSRC_DIR directory exists
499 513 if [ -n "$NEXMONSRC_DIR" ] && [ ! -d "$NEXMONSRC_DIR" ] ; then
500 514 echo "error: '${NEXMONSRC_DIR}' specified directory not found (NEXMONSRC_DIR)!"
501 515 exit 1
502 516 fi
503 517
504 518 # Check if specified CHROOT_SCRIPTS directory exists
505 519 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
506 520 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
507 521 exit 1
508 522 fi
509 523
510 524 # Check if specified device mapping already exists (will be used by cryptsetup)
511 525 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
512 526 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
513 527 exit 1
514 528 fi
515 529
516 530 # Don't clobber an old build
517 531 if [ -e "$BUILDDIR" ] ; then
518 532 echo "error: directory ${BUILDDIR} already exists, not proceeding"
519 533 exit 1
520 534 fi
521 535
522 536 # Setup chroot directory
523 537 mkdir -p "${R}"
524 538
525 539 # Check if build directory has enough of free disk space >512MB
526 540 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
527 541 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
528 542 exit 1
529 543 fi
530 544
531 545 set -x
532 546
533 547 # Call "cleanup" function on various signals and errors
534 548 trap cleanup 0 1 2 3 6
535 549
536 550 # Add required packages for the minbase installation
537 551 if [ "$ENABLE_MINBASE" = true ] ; then
538 552 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
539 553 fi
540 554
541 555 # Add parted package, required to get partprobe utility
542 556 if [ "$EXPANDROOT" = true ] ; then
543 557 APT_INCLUDES="${APT_INCLUDES},parted"
544 558 fi
545 559
546 560 # Add dphys-swapfile package, required to enable swap
547 561 if [ "$ENABLE_DPHYSSWAP" = true ] ; then
548 562 APT_INCLUDES="${APT_INCLUDES},dphys-swapfile"
549 563 fi
550 564
551 565 # Add dbus package, recommended if using systemd
552 566 if [ "$ENABLE_DBUS" = true ] ; then
553 567 APT_INCLUDES="${APT_INCLUDES},dbus"
554 568 fi
555 569
556 570 # Add iptables IPv4/IPv6 package
557 571 if [ "$ENABLE_IPTABLES" = true ] ; then
558 572 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
559 573 fi
560 574 # Add apparmor for KERNEL_SECURITY
561 575 if [ "$KERNEL_SECURITY" = true ] ; then
562 576 APT_INCLUDES="${APT_INCLUDES},apparmor,apparmor-utils,apparmor-profiles,apparmor-profiles-extra,libapparmor-perl"
563 577 fi
564 578
565 579 # Add openssh server package
566 580 if [ "$ENABLE_SSHD" = true ] ; then
567 581 APT_INCLUDES="${APT_INCLUDES},openssh-server"
568 582 fi
569 583
570 584 # Add alsa-utils package
571 585 if [ "$ENABLE_SOUND" = true ] ; then
572 586 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
573 587 fi
574 588
575 589 # Add rng-tools package
576 590 if [ "$ENABLE_HWRANDOM" = true ] ; then
577 591 APT_INCLUDES="${APT_INCLUDES},rng-tools"
578 592 fi
579 593
580 594 # Add fbturbo video driver
581 595 if [ "$ENABLE_FBTURBO" = true ] ; then
582 596 # Enable xorg package dependencies
583 597 ENABLE_XORG=true
584 598 fi
585 599
586 600 # Add user defined window manager package
587 601 if [ -n "$ENABLE_WM" ] ; then
588 602 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
589 603
590 604 # Enable xorg package dependencies
591 605 ENABLE_XORG=true
592 606 fi
593 607
594 608 # Add xorg package
595 609 if [ "$ENABLE_XORG" = true ] ; then
596 610 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
597 611 fi
598 612
599 613 # Replace selected packages with smaller clones
600 614 if [ "$ENABLE_REDUCE" = true ] ; then
601 615 # Add levee package instead of vim-tiny
602 616 if [ "$REDUCE_VIM" = true ] ; then
603 617 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
604 618 fi
605 619
606 620 # Add dropbear package instead of openssh-server
607 621 if [ "$REDUCE_SSHD" = true ] ; then
608 622 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
609 623 fi
610 624 fi
611 625
612 626 # Configure systemd-sysv exclude to make halt/reboot/shutdown scripts available
613 627 if [ "$ENABLE_SYSVINIT" = false ] ; then
614 628 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
615 629 fi
616 630
617 631 # Configure kernel sources if no KERNELSRC_DIR
618 632 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
619 633 KERNELSRC_CONFIG=true
620 634 fi
621 635
622 636 # Configure reduced kernel
623 637 if [ "$KERNEL_REDUCE" = true ] ; then
624 638 KERNELSRC_CONFIG=false
625 639 fi
626 640
627 641 # Configure qemu compatible kernel
628 642 if [ "$ENABLE_QEMU" = true ] ; then
629 643 DTB_FILE=vexpress-v2p-ca15_a7.dtb
630 644 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
631 645 KERNEL_DEFCONFIG="vexpress_defconfig"
632 646 if [ "$KERNEL_MENUCONFIG" = false ] ; then
633 647 KERNEL_OLDDEFCONFIG=true
634 648 fi
635 649 fi
636 650
637 651 # Execute bootstrap scripts
638 652 for SCRIPT in bootstrap.d/*.sh; do
639 653 head -n 3 "$SCRIPT"
640 654 . "$SCRIPT"
641 655 done
642 656
643 657 ## Execute custom bootstrap scripts
644 658 if [ -d "custom.d" ] ; then
645 659 for SCRIPT in custom.d/*.sh; do
646 660 . "$SCRIPT"
647 661 done
648 662 fi
649 663
650 664 # Execute custom scripts inside the chroot
651 665 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
652 666 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
653 667 chroot_exec /bin/bash -x <<'EOF'
654 668 for SCRIPT in /chroot_scripts/* ; do
655 669 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
656 670 $SCRIPT
657 671 fi
658 672 done
659 673 EOF
660 674 rm -rf "${R}/chroot_scripts"
661 675 fi
662 676
663 677 # Remove c/c++ build environment from the chroot
664 678 chroot_remove_cc
665 679
666 680 # Generate required machine-id
667 681 MACHINE_ID=$(dbus-uuidgen)
668 682 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
669 683 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
670 684
671 685 # APT Cleanup
672 686 chroot_exec apt-get -y clean
673 687 chroot_exec apt-get -y autoclean
674 688 chroot_exec apt-get -y autoremove
675 689
676 690 # Unmount mounted filesystems
677 691 umount -l "${R}/proc"
678 692 umount -l "${R}/sys"
679 693
680 694 # Clean up directories
681 695 rm -rf "${R}/run/*"
682 696 rm -rf "${R}/tmp/*"
683 697
684 698 # Clean up APT proxy settings
685 699 if [ "$KEEP_APT_PROXY" = false ] ; then
686 700 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
687 701 fi
688 702
689 703 # Clean up files
690 704 rm -f "${ETC_DIR}/ssh/ssh_host_*"
691 705 rm -f "${ETC_DIR}/dropbear/dropbear_*"
692 706 rm -f "${ETC_DIR}/apt/sources.list.save"
693 707 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
694 708 rm -f "${ETC_DIR}/*-"
695 709 rm -f "${ETC_DIR}/resolv.conf"
696 710 rm -f "${R}/root/.bash_history"
697 711 rm -f "${R}/var/lib/urandom/random-seed"
698 712 rm -f "${R}/initrd.img"
699 713 rm -f "${R}/vmlinuz"
700 714 rm -f "${R}${QEMU_BINARY}"
701 715
702 716 if [ "$ENABLE_QEMU" = true ] ; then
703 717 # Setup QEMU directory
704 718 mkdir "${BASEDIR}/qemu"
705 719
706 720 # Copy kernel image to QEMU directory
707 721 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
708 722
709 723 # Copy kernel config to QEMU directory
710 724 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
711 725
712 726 # Copy kernel dtbs to QEMU directory
713 727 for dtb in "${BOOT_DIR}/"*.dtb ; do
714 728 if [ -f "${dtb}" ] ; then
715 729 install_readonly "${dtb}" "${BASEDIR}/qemu/"
716 730 fi
717 731 done
718 732
719 733 # Copy kernel overlays to QEMU directory
720 734 if [ -d "${BOOT_DIR}/overlays" ] ; then
721 735 # Setup overlays dtbs directory
722 736 mkdir "${BASEDIR}/qemu/overlays"
723 737
724 738 for dtb in "${BOOT_DIR}/overlays/"*.dtbo ; do
725 739 if [ -f "${dtb}" ] ; then
726 740 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
727 741 fi
728 742 done
729 743 fi
730 744
731 745 # Copy u-boot files to QEMU directory
732 746 if [ "$ENABLE_UBOOT" = true ] ; then
733 747 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
734 748 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
735 749 fi
736 750 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
737 751 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
738 752 fi
739 753 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
740 754 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
741 755 fi
742 756 fi
743 757
744 758 # Copy initramfs to QEMU directory
745 759 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
746 760 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
747 761 fi
748 762 fi
749 763
750 764 # Calculate size of the chroot directory in KB
751 765 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
752 766
753 767 # Calculate the amount of needed 512 Byte sectors
754 768 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
755 769 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
756 770 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
757 771
758 772 # The root partition is EXT4
759 773 # This means more space than the actual used space of the chroot is used.
760 774 # As overhead for journaling and reserved blocks 35% are added.
761 775 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
762 776
763 777 # Calculate required image size in 512 Byte sectors
764 778 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
765 779
766 780 # Prepare image file
767 781 if [ "$ENABLE_SPLITFS" = true ] ; then
768 782 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
769 783 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
770 784 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
771 785 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
772 786
773 787 # Write firmware/boot partition tables
774 788 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
775 789 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
776 790 EOM
777 791
778 792 # Write root partition table
779 793 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
780 794 ${TABLE_SECTORS},${ROOT_SECTORS},83
781 795 EOM
782 796
783 797 # Setup temporary loop devices
784 798 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
785 799 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
786 800 else # ENABLE_SPLITFS=false
787 801 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
788 802 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
789 803
790 804 # Write partition table
791 805 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
792 806 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
793 807 ${ROOT_OFFSET},${ROOT_SECTORS},83
794 808 EOM
795 809
796 810 # Setup temporary loop devices
797 811 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
798 812 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
799 813 fi
800 814
801 815 if [ "$ENABLE_CRYPTFS" = true ] ; then
802 816 # Create dummy ext4 fs
803 817 mkfs.ext4 "$ROOT_LOOP"
804 818
805 819 # Setup password keyfile
806 820 touch .password
807 821 chmod 600 .password
808 822 echo -n ${CRYPTFS_PASSWORD} > .password
809 823
810 824 # Initialize encrypted partition
811 825 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
812 826
813 827 # Open encrypted partition and setup mapping
814 828 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
815 829
816 830 # Secure delete password keyfile
817 831 shred -zu .password
818 832
819 833 # Update temporary loop device
820 834 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
821 835
822 836 # Wipe encrypted partition (encryption cipher is used for randomness)
823 837 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
824 838 fi
825 839
826 840 # Build filesystems
827 841 mkfs.vfat "$FRMW_LOOP"
828 842 mkfs.ext4 "$ROOT_LOOP"
829 843
830 844 # Mount the temporary loop devices
831 845 mkdir -p "$BUILDDIR/mount"
832 846 mount "$ROOT_LOOP" "$BUILDDIR/mount"
833 847
834 848 mkdir -p "$BUILDDIR/mount/boot/firmware"
835 849 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
836 850
837 851 # Copy all files from the chroot to the loop device mount point directory
838 852 rsync -a "${R}/" "$BUILDDIR/mount/"
839 853
840 854 # Unmount all temporary loop devices and mount points
841 855 cleanup
842 856
843 857 # Create block map file(s) of image(s)
844 858 if [ "$ENABLE_SPLITFS" = true ] ; then
845 859 # Create block map files for "bmaptool"
846 860 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
847 861 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
848 862
849 863 # Image was successfully created
850 864 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
851 865 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
852 866 else
853 867 # Create block map file for "bmaptool"
854 868 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
855 869
856 870 # Image was successfully created
857 871 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
858 872
859 873 # Create qemu qcow2 image
860 874 if [ "$ENABLE_QEMU" = true ] ; then
861 875 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
862 876 QEMU_SIZE=16G
863 877
864 878 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
865 879 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
866 880
867 881 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
868 882 fi
869 883 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant